#if !defined(__ASSOCIATION_H_INCLUDED)
#define __ASSOCIATION_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

///////////////////////////////////////////////////////////////
//INCLUDE
#include "resource.h"
#include <windows.h>
#include <winreg.h>

///////////////////////////////////////////////////////////////
//DEFINE
#define FINDTYPE_APPNAME		(0)
#define FINDTYPE_EXT			(1)

///////////////////////////////////////////////////////////////
//TYPEDEF
//MOD START HOUMING (\́NX)
class CApplicationList	//MOD GORIPON
{
private:	//MOD GORIPON
	LPTSTR							lpszExt;
	LPTSTR							lpszKeyName;
	LPTSTR							lpszAppName;
	LPTSTR							lpszAppPath;
	LPTSTR							lpszCommand;
	LPTSTR							lpszIconPath;
	int								nIconID;
	int								nImageIndex;
//MOD START GORIPON
	CApplicationList				*lpNext;
public:
	CApplicationList();
	CApplicationList(LPTSTR szExt,LPTSTR szKeyName,LPTSTR szAppName,LPTSTR szAppPath,LPTSTR szCommand,LPTSTR szIconPath,int IconID,int ImageIndex,CApplicationList* AlPrev=NULL)
	{
		lpszExt = NULL;
		lpszKeyName = NULL;
		lpszAppName = NULL;
		lpszAppPath = NULL;
		lpszCommand = NULL;
		lpszIconPath = NULL;
		setExt(szExt);
		setKeyName(szKeyName);
		setAppName(szAppName);
		setAppPath(szAppPath);
		setCommand(szCommand);
		setIconPath(szIconPath);
		setIconID(IconID);
		setImageIndex(ImageIndex);
//MOD END
		nIconID=IconID;
		nImageIndex=ImageIndex;
//ADD START GORIPON
		lpNext=NULL;
		if (AlPrev) {AlPrev->lpNext=this;}
//ADD END
	};
	~CApplicationList(){delete[] lpszExt; delete[] lpszKeyName; delete[] lpszAppName; delete[] lpszAppPath; delete[] lpszCommand; delete[] lpszIconPath; delete lpNext;}	//MOD GORIPON
//ADD START GORIPON
	LPTSTR getExt(){return lpszExt?lpszExt:_T("");}
	LPTSTR getKeyName(){return lpszKeyName?lpszKeyName:_T("");}
	LPTSTR getAppName(){return lpszAppName?lpszAppName:_T("");}
	LPTSTR getAppPath(){return lpszAppPath?lpszAppPath:_T("");}
	LPTSTR getCommand(){return lpszCommand?lpszCommand:_T("");}
	LPTSTR getIconPath(){return lpszIconPath?lpszIconPath:_T("");}
	int getIconID(){return nIconID;}
	int getImageIndex(){return nImageIndex;}
	CApplicationList* getNext(){return lpNext;}
	void setExt(LPTSTR szExt){delete[] lpszExt;if(szExt && _tcslen(szExt)){lpszExt=new TCHAR[_tcslen(szExt)+1];_tcscpy(lpszExt,szExt);}else{lpszExt=NULL;}}
	void setKeyName(LPTSTR szKeyName){delete[] lpszKeyName;if(szKeyName && _tcslen(szKeyName)){lpszKeyName=new TCHAR[_tcslen(szKeyName)+1];_tcscpy(lpszKeyName,szKeyName);}else{lpszKeyName=NULL;}}
	void setAppName(LPTSTR szAppName){delete[] lpszAppName;if(szAppName && _tcslen(szAppName)){lpszAppName=new TCHAR[_tcslen(szAppName)+1];_tcscpy(lpszAppName,szAppName);}else{lpszAppName=NULL;}}
	void setAppPath(LPTSTR szAppPath){delete[] lpszAppPath;if(szAppPath && _tcslen(szAppPath)){lpszAppPath=new TCHAR[_tcslen(szAppPath)+1];_tcscpy(lpszAppPath,szAppPath);}else{lpszAppPath=NULL;}}
	void setCommand(LPTSTR szCommand){delete[] lpszCommand;if(szCommand && _tcslen(szCommand)){lpszCommand=new TCHAR[_tcslen(szCommand)+1];_tcscpy(lpszCommand,szCommand);}else{lpszCommand=NULL;}}
	void setIconPath(LPTSTR szIconPath){delete[] lpszIconPath;if(szIconPath && _tcslen(szIconPath)){lpszIconPath=new TCHAR[_tcslen(szIconPath)+1];_tcscpy(lpszIconPath,szIconPath);}else{lpszIconPath=NULL;}}
	void setIconID(int IconID){nIconID=IconID;}
	void setImageIndex(int ImageIndex){nImageIndex=ImageIndex;}
	void setNext(CApplicationList* Next){lpNext=Next;}
//ADD END
};
//MOD END

///////////////////////////////////////////////////////////////
//PROTOTYPE
LRESULT CALLBACK PPOptionFiletypeProc(HWND,UINT,WPARAM,LPARAM);

///////////////////////////////////////////////////////////////
//CLASS
class CAssociation
{
public:
	HWND				m_hparWnd;
	HINSTANCE			m_hInst;
	HWND				m_hWnd;
	BOOL				m_bReg;
	BOOL				m_bOpen;

	HWND				m_hListView;
	HWND				m_hListView2;
	HIMAGELIST			m_hImageList;
//MOD START GORIPON
	CApplicationList*	m_lpAppList;
	CApplicationList*	m_lpActiveList;
//MOD END
	TCHAR				m_szCurrent[MAX_PATH];
	TCHAR				m_szName[MAX_PATH];
	TCHAR				m_szExtType[MAX_PATH];
	TCHAR				m_szNewFileType[MAX_PATH];
	LPTSTR				m_lpszExt;
	BOOL				m_nbSortRaise;

public:
	CAssociation(HWND,HINSTANCE);
	~CAssociation();
	void CreateAppList();
	void CreateAppList2();
	void DeleteAppList();

	BOOL SetApplication(LPTSTR,LPTSTR lpszKeyName=NULL,LPTSTR lpszAppName=NULL,LPTSTR lpszParam=NULL, LPTSTR lpszIconPath=NULL, int nIconID=0);
	BOOL SetAssociation(LPTSTR);
	BOOL DeleteSubKey(LPTSTR);

	void InitAppImageList(HWND);
	void DeleteAppImageList();
	void LoadAppList(LPTSTR szSelectAppPath=NULL);
	void LoadAppList2();
	CApplicationList* GetSelectItem(HWND,int,int nType=FINDTYPE_APPNAME);	//MOD GORIPON

	int OpenChoose(LPTSTR,LPTSTR,BOOL bReg=FALSE, BOOL bOpen=TRUE);
	void OnInitChoose();
	void OnEndChoose();
	void OnBrowseChoose();
	void OnOKChoose();

	void OnInitFiletype();
	void OnEndFiletype();
	void OnClickFiletype();
	void OnChangeFiletype(LPTSTR lpszExt=NULL);
	void OnColumnClick(NMLISTVIEW*);
	void OpenNewFiletype();
	void OnInitNewFiletype(HWND);
	BOOL OnOKNewFiletype(HWND);
	void OpenDeleteFiletype();
	void OpenDetailSetting();
	void OnInitDetailSetting(HWND);
	void OnChangeDetailSetting(HWND);
	BOOL OnOKDetailSetting(HWND);
//ADD START GORIPON
	void OnSizeChoose();
	void OnSizeFiletype();
//ADD END
};
///////////////////////////////////////////////////////////////
#endif // !defined(__ASSOCIATION_H_INCLUDED)